#!/usr/bin/irssi

use strict;
use Irssi;
use Fcntl qw(O_RDONLY O_NONBLOCK);
use POSIX qw(mkfifo);
use vars qw($VERSION %IRSSI);

$VERSION = "0.1";
%IRSSI = (
	authors 	=> "Olivier Blin",
	contact 	=> 'blino@mandrake.org',
	name 		=> "drakcowsay",
	description 	=> "Prints cowsays sent by drakcowsay",
	license 	=> "Public Domain",
        url		=> "http://peoples.mandrakesoft.com/~blino/drakcowsay/"
);

my $drakcowsay_timeout = 1000;
my $fifo = $ENV{HOME} . "/.drakcowsay-fifo";
my $F;

sub drakcowsay_timeout_cb {
    if (my @lines = <$F>) {
        chomp @lines;
        Irssi::active_win()->command("say $_") foreach @lines;
    }
    close $F;
    sysopen($F, $fifo, O_RDONLY | O_NONBLOCK) or die "unable to open fifo";
}

unlink($fifo);
mkfifo($fifo, 0666);
sysopen($F, $fifo, O_RDONLY | O_NONBLOCK) or die "unable to open fifo";

Irssi::timeout_add($drakcowsay_timeout, \&drakcowsay_timeout_cb, undef);
